package Schwimmbad;

public class Schwimmbad {
   private static int maxLiegen;
   private int anzahlGaeste;

   public Schwimmbad(int maxLiegen) {
	   Schwimmbad.maxLiegen = maxLiegen;
       this.anzahlGaeste = 0;
   }
     
   public synchronized void betreten() {
       try {
		   // Anzahl vor Betreten des Derhkreuzes ueberpruefen!
           while(anzahlGaeste >= maxLiegen) {
               wait();               
           }
       }
       catch(InterruptedException ie)  {}
       // Dann Anzahl erhoehen.
       anzahlGaeste++;
       System.out.println(
               Thread.currentThread().getName()+" betritt Schwimmbad ---> ("
               + anzahlGaeste + " anwesend)");
   }

   public synchronized void verlassen() {
       
	   anzahlGaeste--;
	   notify();
	   System.out.println(
               Thread.currentThread().getName()+" verlaesst Schwimmbad  <--- ("
               + anzahlGaeste + " anwesend)");
   }
   
}
